/*  Project: Open Source Gmini Tools
    file: BreakpointList.h, header file for BreakpointList.cpp

    Copyright (C) 2004  The gmEmu Project <gmemu@donat.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef BreakpointList_H
#define BreakpointList_H

#include <vector>
using namespace std;
#include "Breakpoint.h"

class BreakpointList {
 private:
   unsigned int lastBreak;
      vector < Breakpoint * >Breakpoints;
 public:
      bool breakPointEnabled;
   // whenever a breakpoint is triggered; breakpoints are 
   // disabled until further notice.
   // In practise, CPUCore re-enables them as soon as something is interpreted.

      BreakpointList(  ) {
      breakPointEnabled = true;
      lastBreak = 0xFFFFFFFF;
   } void BPX( u22 address );
   void BPM( u22 address, unsigned int access );
   void BPR( u22 start, u22 end, unsigned int access );
   bool isBreakpoint( u22 address, unsigned int access );
   unsigned int getBreak(  ) {
      return lastBreak;
   }
   void del( unsigned int );
   void clear(  );
   void Print(  );
   void Print( unsigned int );
};
#endif
