
 /* Project: Open Source Gmini Tools file: trace.cpp, Logs events

    Copyright (C) 2004 The gmEmu Project <gmemu@donat.org>

    This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public
    License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any
    later version.

    This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
    details.

    You should have received a copy of the GNU General Public License along with this program; if not, write to the
    Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA */

class Emulator;

#ifndef EMULATOR_H
#define EMULATOR_H

#include "ADC.h"
#include "MMU.h"
#include "CPUCore.h"
#include "MMIO.h"
#include "IDEController.h"
#include "LCDController.h"
#include "I2CBus.h"
#include "Console.h"
#include "trace.h"
#include "BreakpointList.h"
#include "SymMap.h"
#include "CommentMap.h"
#include "LCD.h"

class Emulator {
 public:
   // gmini parts
   CPUCore cpu;
   MMU memory;
   MMIO io;
   IDEController* ide;
   LCDController lcdi;
   I2CBus i2c;
   LCD lcd;
   ADC adc;
   fstream uart;
   fstream audio;
   int uartIn;                  // FD

   // debugging facilities
   BreakpointList BL;
   SymMap *symbols;
   CommentMap *comments;
   Tracer tracer;

 public:
   Emulator( int argc, const char *argv[] );
   void saveState();
   void restoreState();
   ~Emulator(  );
};

#endif
