
#ifndef I2CBUS_H
#define I2CBUS_H

#include "types.h"

#define I2C_MAXTRANSFER 1024

class Emulator;
class I2CBus {
 public:
   enum { SCL = 0, SDA = 1, LINE_END };
 private:
      bool masterState[LINE_END];   // what master sets
   bool slaveState[LINE_END];   // what slave sets
   bool lineState[LINE_END];    // result state (AND)

   // current transfer state
   bool transfer;               // transfer going on ?
   int bitIndex, byteIndex;
   u8 byteBuffer;
   int slaveAddress;
   int direction;
   // 0: master => slave
   // 1: master <= slave

   u8 transferBuffer[I2C_MAXTRANSFER];

 public:
   I2CBus( Emulator * gm );
   void lineInteractMaster( int line, bool write, bool & state );
   // line: either SCL or SDA
   // write: are we writing or reading the line
   // state: state of the line (read or written)
 private:
   Emulator * gmini;
   void lineNotifySlave( int line, bool state );
   void setSlaveState( int line, bool state );
   void requestSlaveData(  );
   void feedSlaveData(  );
   void processAudioCommand(u8* data);

};

#endif
