
#include "panic.h"
#include "lcd.h"
#include "crt1.h"
#include "stdlib.h"
#include "MMIO.h"
#include "sprintf.h"
#include "hwgmini.h"


int main() {
  clear_watchdog();
  lcd_init();
  char buffer[200];
  lcd_puts(0,0, "Sampling ...");
  lcd_update();  
  while (1) {
    int c6min, c6max, c7min, c7max;
    c7min = c6min = 0x400;
    c7max = c6max = 0;

    for (int i = 0; i < 5000; i++) {
      clear_watchdog();
      int ch6 = adc_chan_busy(6);
      int ch7 = adc_chan_busy(7);
      if (ch6 < c6min)
	c6min = ch6;
      if (ch6 > c6max)
	c6max = ch6;

      if (ch7 < c7min)
	c7min = ch7;
      if (ch7 > c7max)
	c7max = ch7;
    }

    int ch0 = adc_chan_busy(0);
    int ch1 = adc_chan_busy(1);
    int ch2 = adc_chan_busy(2);
    int ch3 = adc_chan_busy(3);
    int ch4 = adc_chan_busy(4);
    int ch5 = adc_chan_busy(5);
    
    lcd_clear_display();
    snprintf(buffer, 200, "%03x < ch6 < %03x", c6min, c6max);
    lcd_puts(0,0, buffer);
    snprintf(buffer, 200, "%03x < ch7 < %03x", c7min, c7max);
    lcd_puts(0,1, buffer);
    snprintf(buffer, 200, "0=%03x 1=%03x 2=%03x", ch0, ch1, ch2);
    lcd_puts(0,2, buffer);
    snprintf(buffer, 200, "3=%03x 4=%03x 5=%03x", ch3, ch4, ch5);
    lcd_puts(0,3, buffer);
    
    lcd_update();
  }
}
